local T, C, L = unpack(select(2, ...)) -- Import: T - functions, constants, variables; C - config; L - locales
-----------------------------------------------------------------------------
-- Copy on chatframes feature
-----------------------------------------------------------------------------

if C["chat"].enable ~= true then return end

local lines = {}
local frame = nil
local editBox = nil
local isf = nil

local function CreatCopyFrame()
	frame = CreateFrame("Frame", "CopyFrame", UIParent)
	frame:SetTemplate("Transparent")
	frame:Width(TukuiBar1:GetWidth())
	frame:Height(250)
	frame:SetScale(1)
	frame:Point("BOTTOM", TukuiBar1, "BOTTOM", 0, 0)
	frame:CreateShadow("Default")
	frame:Hide()
	frame:SetFrameStrata("DIALOG")

	local scrollArea = CreateFrame("ScrollFrame", "CopyScroll", frame, "UIPanelScrollFrameTemplate")
	scrollArea:Point("TOPLEFT", frame, "TOPLEFT", 8, -30)
	scrollArea:Point("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -30, 8)

	editBox = CreateFrame("EditBox", "CopyBox", frame)
	editBox:SetMultiLine(true)
	editBox:SetMaxLetters(99999)
	editBox:EnableMouse(true)
	editBox:SetAutoFocus(false)
	editBox:SetFontObject(ChatFontNormal)
	editBox:Width(TukuiBar1:GetWidth())
	editBox:Height(250)
	editBox:SetScript("OnEscapePressed", function() frame:Hide() end)

	scrollArea:SetScrollChild(editBox)

	local close = CreateFrame("Button", "CopyCloseButton", frame, "UIPanelCloseButton")
	close:SetPoint("TOPRIGHT", frame, "TOPRIGHT")

	isf = true
	T.SkinScrollBar(CopyScrollScrollBar)
	T.SkinCloseButton(CopyCloseButton)
end

local function GetLines(...)
	--[[		Grab all those lines		]]--
	local ct = 1
	for i = select("#", ...), 1, -1 do
		local region = select(i, ...)
		if region:GetObjectType() == "FontString" then
			lines[ct] = tostring(region:GetText())
			ct = ct + 1
		end
	end
	return ct - 1
end

local function Copy(cf)
	local _, size = cf:GetFont()
	FCF_SetChatWindowFontSize(cf, cf, 0.01)
	local lineCt = GetLines(cf:GetRegions())
	local text = table.concat(lines, "\n", 1, lineCt)
	FCF_SetChatWindowFontSize(cf, cf, size)
	if not isf then CreatCopyFrame() end
	if frame:IsShown() then frame:Hide() return end
	frame:Show()
	editBox:SetText(text)
end

local function ChatCopyButtons()
	for i = 1, NUM_CHAT_WINDOWS do
		local cf = _G[format("ChatFrame%d",  i)]
		local button = CreateFrame("Button", format("ButtonCF%d", i), cf)
		local id = cf:GetID()
		local point = GetChatWindowSavedPosition(id)
		button:Size(20, 20)
		button:Point("TOPRIGHT", 0, 24)
		
		local buttontext = button:CreateFontString(nil,"OVERLAY",nil)
		buttontext:SetFont(T.SetUserFont())
		buttontext:SetText(T.panelcolor.."C")
		buttontext:Point("CENTER", 5, -1)
		buttontext:SetJustifyH("CENTER")
		buttontext:SetJustifyV("CENTER")

		button:SetScript("OnMouseUp", function(self, btn)
			if btn == "RightButton" then
				ToggleFrame(ChatMenu)
			else
				Copy(cf)
			end
		end)
		button:SetScript("OnEnter", function() button:SetAlpha(1) buttontext:SetText("C") end)

		local bnb = function() -- just to shorten the code
			button:SetAlpha(0)
			button:SetScript("OnLeave", function() button:SetAlpha(0) buttontext:SetText(T.panelcolor.."C") end)
			button:ClearAllPoints()
			button:SetPoint("TOPRIGHT", 0, 0)
			button:SetTemplate("Default")
		end
		
		-- check chat position
		if point == "BOTTOMLEFT" or point == "LEFT" then
			if C["chat"].background then
				button:SetScript("OnLeave", function() buttontext:SetText(T.panelcolor.."C") end)
				if i == 2 and GetChannelName("Log") and not IsAddOnLoaded("nibHideBlackBar") then
					button:Point("TOPRIGHT", 0, 48)
				end
			else
				bnb()
			end
		elseif point == "BOTTOMRIGHT" or point == "RIGHT" then
			if C["chat"].background then
				button:SetScript("OnLeave", function() buttontext:SetText(T.panelcolor.."C") end)
			else
				bnb()
			end
		else
			if C["chat"].background then
				if i == 2 and GetChannelName("Log") then
					button:Point("TOPRIGHT", 0, 48)
				end
				button:SetScript("OnLeave", function() buttontext:SetText(T.panelcolor.."C") end)
			else
				bnb()
			end
		end
	end
end
ChatCopyButtons()

-- little fix for RealID text copy/paste (real name bug)
for i=1, NUM_CHAT_WINDOWS do
	local editbox = _G["ChatFrame"..i.."EditBox"]
	editbox:HookScript("OnTextChanged", function(self)
		local text = self:GetText()
    
		local new, found = gsub(text, "|Kf(%S+)|k(%S+)%s(%S+)k:%s", "%2 %3: ")
    
		if found > 0 then
			new = new:gsub('|', '')
			self:SetText(new)
		end
	end)
end